#include "art_root_io/FastCloningInfoProvider.h"

#include "art/Framework/Core/DecrepitRelicInputSourceImplementation.h"
#include "canvas/Utilities/Exception.h"

art::FastCloningInfoProvider::FastCloningInfoProvider(
  cet::exempt_ptr<DecrepitRelicInputSourceImplementation> input)
  : input_(input)
{}

off_t
art::FastCloningInfoProvider::remainingEvents() const
{
  if (!fastCloningPermitted()) {
    throw Exception(errors::LogicError)
      << "FastCloningInfoProvider::remainingEvents() has no meaning"
      << " in this context:\n"
      << "Check fastCloningPermitted() first.\n";
  }
  return input_->remainingEvents();
}

off_t
art::FastCloningInfoProvider::remainingSubRuns() const
{
  if (!fastCloningPermitted()) {
    throw Exception(errors::LogicError)
      << "FastCloningInfoProvider::remainingSubRuns() has no meaning"
      << " in this context:\n"
      << "Check fastCloningPermitted() first.\n";
  }
  return input_->remainingSubRuns();
}
